Package javax.media.j3d

# Class RotationPathInterpolator

java.lang.Object
javax.media.j3d.SceneGraphObject
javax.media.j3d.Node
javax.media.j3d.Leaf
javax.media.j3d.Behavior
javax.media.j3d.Interpolator
javax.media.j3d.TransformInterpolator
javax.media.j3d.PathInterpolator
javax.media.j3d.RotationPathInterpolator

public class RotationPathInterpolator extends PathInterpolator
RotationPathInterpolator behavior. This class defines a behavior that varies the rotational component of its target TransformGroup by linearly interpolating among a series of predefined knot/orientation pairs (using the value generated by the specified Alpha object). The interpolated orientation is used to generate a rotation transform in the local coordinate system. The first knot must have a value of 0.0. The last knot must have a value of 1.0. An intermediate knot with index k must have a value strictly greater than any knot with index less than k.

## Field Summary

### Fields inherited from class javax.media.j3d.PathInterpolator

`currentInterpolationValue, currentKnotIndex`

### Fields inherited from class javax.media.j3d.TransformInterpolator

`axis, axisInverse, target`

### Fields inherited from class javax.media.j3d.Interpolator

`defaultWakeupCriterion`

### Fields inherited from class javax.media.j3d.Node

`ALLOW_AUTO_COMPUTE_BOUNDS_READ, ALLOW_AUTO_COMPUTE_BOUNDS_WRITE, ALLOW_BOUNDS_READ, ALLOW_BOUNDS_WRITE, ALLOW_COLLIDABLE_READ, ALLOW_COLLIDABLE_WRITE, ALLOW_LOCAL_TO_VWORLD_READ, ALLOW_LOCALE_READ, ALLOW_PARENT_READ, ALLOW_PICKABLE_READ, ALLOW_PICKABLE_WRITE, ENABLE_COLLISION_REPORTING, ENABLE_PICK_REPORTING`

## Constructor Summary

Constructors
Constructor
Description
`RotationPathInterpolator(Alpha alpha, TransformGroup target, Transform3D axisOfTransform, float[] knots, javax.vecmath.Quat4f[] quats)`
Constructs a new RotationPathInterpolator object that varies the target TransformGroup node's transform.

## Method Summary

Modifier and Type
Method
Description
`Node`
`cloneNode(boolean forceDuplicate)`
Used to create a new instance of the node.
`void`
`computeTransform(float alphaValue, Transform3D transform)`
Computes the new transform for this interpolator for a given alpha value.
`Transform3D`
`getAxisOfRotation()`
Deprecated.
As of Java 3D version 1.3, replaced by `TransformInterpolator.getTransformAxis()`
`void`
`getQuat(int index, javax.vecmath.Quat4f quat)`
Retrieves the quat value at the specified index.
`void`
`getQuats(javax.vecmath.Quat4f[] quats)`
Copies the array of quaternion values from this interpolator into the specified array.
`void`
`setAxisOfRotation(Transform3D axisOfRotation)`
Deprecated.
As of Java 3D version 1.3, replaced by `TransformInterpolator.seTransformAxis(Transform3D)`
`void`
`setPathArrays(float[] knots, javax.vecmath.Quat4f[] quats)`
Replaces the existing arrays of knot values and quaternion values with the specified arrays.
`void`
`setQuat(int index, javax.vecmath.Quat4f quat)`
Sets the quat value at the specified index for this interpolator.

### Methods inherited from class javax.media.j3d.PathInterpolator

`computePathInterpolation, computePathInterpolation, getArrayLengths, getKnot, getKnots, setKnot, setKnots`

### Methods inherited from class javax.media.j3d.TransformInterpolator

`getTarget, getTransformAxis, processStimulus, setTarget, setTransformAxis, updateNodeReferences`

### Methods inherited from class javax.media.j3d.Interpolator

`getAlpha, initialize, setAlpha`

### Methods inherited from class javax.media.j3d.Behavior

`getEnable, getNumSchedulingIntervals, getSchedulingBoundingLeaf, getSchedulingBounds, getSchedulingInterval, getView, getWakeupCondition, postId, setEnable, setSchedulingBoundingLeaf, setSchedulingBounds, setSchedulingInterval, wakeupOn`

### Methods inherited from class javax.media.j3d.Node

`cloneTree, cloneTree, cloneTree, cloneTree, cloneTree, cloneTree, duplicateNode, getBounds, getBoundsAutoCompute, getCollidable, getLocale, getLocalToVworld, getLocalToVworld, getParent, getPickable, setBounds, setBoundsAutoCompute, setCollidable, setPickable`

### Methods inherited from class javax.media.j3d.SceneGraphObject

`clearCapability, clearCapabilityIsFrequent, duplicateSceneGraphObject, getCapability, getCapabilityIsFrequent, getName, getUserData, isCompiled, isLive, setCapability, setCapabilityIsFrequent, setName, setUserData, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### RotationPathInterpolator

public RotationPathInterpolator(Alpha alpha, TransformGroup target, Transform3D axisOfTransform, float[] knots, javax.vecmath.Quat4f[] quats)
Constructs a new RotationPathInterpolator object that varies the target TransformGroup node's transform.

Parameters:
  `alpha` - the alpha object of this interpolator
  `target` - the TransformGroup node affected by this interpolator
  `axisOfTransform` - the transform that defines the local coordinate system in which this interpolator operates
  `knots` - an array of knot values that specify interpolation points
  `quats` - an array of quaternion values at the knots
Throws:
  `IllegalArgumentException` - if the lengths of the knots and quats arrays are not the same.

## Method Details

### setQuat

public void setQuat(int index, javax.vecmath.Quat4f quat)
Sets the quat value at the specified index for this interpolator.

Parameters:
  `index` - the index to be changed
  `quat` - the new quat value at the index

### getQuat

public void getQuat(int index, javax.vecmath.Quat4f quat)
Retrieves the quat value at the specified index.

Parameters:
  `index` - the index of the value requested
  `quat` - the quat object that will have the quat value at index copied into it.

### setPathArrays

public void setPathArrays(float[] knots, javax.vecmath.Quat4f[] quats)
Replaces the existing arrays of knot values and quaternion values with the specified arrays. The arrays of knots and quats are copied into this interpolator object.

Parameters:
  `knots` - a new array of knot values that specify interpolation points
  `quats` - a new array of quaternion values at the knots
Throws:
  `IllegalArgumentException` - if the lengths of the knots and quats arrays are not the same.
Since:
  Java 3D 1.2

### getQuats

public void getQuats(javax.vecmath.Quat4f[] quats)
Copies the array of quaternion values from this interpolator into the specified array. The array must be large enough to hold all of the quats. The individual array elements must be allocated by the caller.

Parameters:
  `quats` - array that will receive the quats
Since:
  Java 3D 1.2

### setAxisOfRotation

public void setAxisOfRotation(Transform3D axisOfRotation)
Deprecated.
As of Java 3D version 1.3, replaced by `TransformInterpolator.seTransformAxis(Transform3D)`

### getAxisOfRotation

public Transform3D getAxisOfRotation()
Deprecated.
As of Java 3D version 1.3, replaced by `TransformInterpolator.getTransformAxis()`

### computeTransform

public void computeTransform(float alphaValue, Transform3D transform)
Computes the new transform for this interpolator for a given alpha value.

Specified by:
  `computeTransform` in class `TransformInterpolator`
Parameters:
  `alphaValue` - alpha value between 0.0 and 1.0
  `transform` - object that receives the computed transform for the specified alpha value
Since:
  Java 3D 1.3

### cloneNode

public Node cloneNode(boolean forceDuplicate)
Used to create a new instance of the node. This routine is called by `cloneTree` to duplicate the current node.

Overrides:
  `cloneNode` in class `Node`
Parameters:
  `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
See Also:
  - `Node.cloneTree()`
  - `Node.cloneNode(boolean)`
  - `Node.duplicateNode(javax.media.j3d.Node, boolean)`
  - `NodeComponent.setDuplicateOnCloneTree(boolean)`